#! /usr/bin/perl
# Script per descarregar tots es vols de lamarabunta.org

#use strict;
use LWP::Simple;
use warnings;
use encoding 'utf8';

my @lin = ();

open F, "./vols_1.txt" or die "No s'ha obert el fitxer!!!";
binmode(F, ":utf8");

# Carregam les dades del fitxer
my $i = 0;
while ($L = <F>) {  # Per a cada linia d'es fitxer
   chop($L);        # Llevam es salt de linia
   $lin[$i] = $L;   # Guardam sa linia
   $i++;
}

close (F);

# Normalitzar noms de especies (posar sempre el tabulador per no modificar els comentaris)
foreach (@lin){
   # Coses que sobren
   $_ =~ s/ \(creo\)\t|\(creo\)\t| Creo\t/\t/g;
   $_ =~ s/\(2 especies diferentes\)\t/\t/g;
   $_ =~ s/ \(sensu Güsten et al.\)\t/\t/g;
   $_ =~ s/\(falta confirmación\)\t/\t/g;
   $_ =~ s/sp \(no barbarus\)\t/sp.\t/g;
   $_ =~ s/\(ruber o lateralis\)\t/\t/g;
   $_ =~ s/ \(grupo caespitum\)\t/\t/g;
   $_ =~ s/\(1 reina alada\)\t/sp.\t/g;
   $_ =~ s/ \(Linnaeus, 1758\)\t/\t/g;
   $_ =~ s/ \(Emery, 1916\)\t/\t/g;
   $_ =~ s/, André, 1883\t/\t/g;
   $_ =~ s/ se supone\t/\t/g;
   $_ =~ s/\treina de /\t/g;
   $_ =~ s/\tvuelo de /\t/g;
   $_ =~ s/\tPosible /\t/g;
   $_ =~ s/, machos\t/\t/g;
   $_ =~ s/\tEspecie /\t/g;
   $_ =~ s/\tGenero /\t/g;
   $_ =~ s/\treina /\t/g;
   $_ =~ s/ alada\t/\t/g;
   $_ =~ s/ gr.\t/\t/g;
   $_ =~ s/ +\t/\t/g;
   # Normalitzar el sp.
   $_ =~ s/ sp\t| s.p.\t| Sp\t| Sp.\t/ sp.\t/g;
   # Genere en mayúscula
   $_ =~ s/\tHipoponera|\thypoponera/\tHypoponera/g;
   $_ =~ s/camponotus sp.\t/Camponotus sp.\t/g;
   $_ =~ s/\tcrematogaster/\tCrematogaster/g;
   $_ =~ s/\taphaenogaster/\tAphaenogaster/g;
   $_ =~ s/lasius niger\t/Lasius niger\t/g;
   $_ =~ s/\todontimachus/\tOdontimachus/g;
   $_ =~ s/\tpogonomyrmex/\tPogonomyrmex/g;
   $_ =~ s/\tcataglyphis/\tCataglyphis/g;
   $_ =~ s/\ttetramorium/\tTetramorium/g;
   $_ =~ s/\tplagiolepis/\tPlagiolepis/g;
   $_ =~ s/\tneivamyrmex/\tNeivamyrmex/g;
   $_ =~ s/\tcamponotus/\tCamponotus/g;
   $_ =~ s/\tcryptopone/\tCryptopone/g;
   $_ =~ s/\tsolenopsis/\tSolenopsis/g;
   $_ =~ s/\ttapinoma/\tTapinoma/g;
   $_ =~ s/\tpheidole/\tPheidole/g;
   $_ =~ s/\tgoniomma/\tGoniomma/g;
   $_ =~ s/\tformica/\tFormica/g;
   $_ =~ s/\tmyrmica/\tMyrmica/g;
   $_ =~ s/\tmessor/\tMessor/g;
   $_ =~ s/\tlasius/\tLasius/g;
   $_ =~ s/atta\t/Atta sp.\t/g;
   # Especie en minúscula
   $_ =~ s/ Scutellaris\t/ scutellaris\t/g;
   $_ =~ s/  Rufibarbis\t/ rufibarbis\t/g;
   $_ =~ s/ Cruentatus\t/ cruentatus\t/g;
   $_ =~ s/ Barbaricus\t/ barbaricus\t/g;
   $_ =~ s/ Pilicornis\t/ pilicornis\t/g;
   $_ =~ s/ Saevissima\t/ saevissima\t/g;
   $_ =~ s/ Dulcineae\t/ dulcineae\t/g;
   $_ =~ s/ Pallidula\t/ pallidula\t/g;
   $_ =~ s/ Capitatus\t/ capitatus\t/g;
   $_ =~ s/ Pratensis\t/ pratensis\t/g;
   $_ =~ s/ Barbarus\t/ barbarus\t/g;
   $_ =~ s/ Structor\t/ structor\t/g;
   $_ =~ s/ Grandis\t/ grandis\t/g;
   $_ =~ s/ Auberti\t/ auberti\t/g;
   $_ =~ s/ Micans\t/ micans\t/g;
   $_ =~ s/ Flavus\t/ flavus\t/g;
   $_ =~ s/ Fallax\t/ fallax\t/g;
   $_ =~ s/ Niger\t/ niger\t/g;
   $_ =~ s/ Fugax\t/ fugax\t/g;
   # Llevar plurals
   $_ =~ s/\tGoniommas/\tGoniomma/g;
   $_ =~ s/\tPheidoles/\tPheidole/g;
   $_ =~ s/\tTapinomas/\tTapinoma/g;
   $_ =~ s/\ttapionas/\tTapinoma/g;
   # Desconeixen especie i no ho indiquen
   $_ =~ s/Lasius y una Lasius parásita Chthonolasius \?\t/Lasius sp.\t/g;
   $_ =~ s/sp \(barbaricus, pilicornis o sylvaticus\)\t/sp.\t/g;
   $_ =~ s/tetramorum, sin confirmar\t/Tetramorium sp.\t/g;
   $_ =~ s/ \(1 Reina sin alas y 2 machos\)\t/ sp.\t/g;
   $_ =~ s/caespitum o tetramorium impurum.\t/sp.\t/g;
   $_ =~ s/LASIUS\t|Lasius\t|Lasius.\t/Lasius sp.\t/g;
   $_ =~ s/2 Lasius sp. diferentes\t/Lasius sp.\t/g;
   $_ =~ s/Messor \(no barbarus\)\t/Messor sp.\t/g;
   $_ =~ s/Crematogaster\t/Crematogaster sp.\t/g;
   $_ =~ s/Cardiocondyla\t/Cardiocondyla sp.\t/g;
   $_ =~ s/Cardicondyla\t/Cardiocondyla sp.\t/g;
   $_ =~ s/Sp.  \( Grandis o Niger \)\t/sp.\t/g;
   $_ =~ s/sylvaticus \/ pilicornis\t/sp.\t/g;
   $_ =~ s/Genero Goniomma\t/Goniomma sp.\t/g;
   $_ =~ s/Messor.\t|Messor\t/Messor sp.\t/g;
   $_ =~ s/Tetramorium\t/Tetramorium sp.\t/g;
   $_ =~ s/Cataglyphis\t/Cataglyphis sp.\t/g;
   $_ =~ s/Tetramorium\t/Tetramorium sp.\t/g;
   $_ =~ s/Cryptopone\t/Cryptopone sp.\t/g;
   $_ =~ s/sylvaticus o barbarus\t/sp.\t/g;
   $_ =~ s/Acromyrmex\t/Acromyrmex sp.\t/g;
   $_ =~ s/Camponotus\t/Camponotus sp.\t/g;
   $_ =~ s/Solenopsis\t/Solenopsis sp.\t/g;
   $_ =~ s/negra tamaño pequeño\t/sp.\t/g;
   $_ =~ s/, negras y rojas.\t/ sp.\t/g;
   $_ =~ s/Tapinoma\t/Tapinoma sp.\t/g;
   $_ =~ s/Pheidole\t/Pheidole sp.\t/g;
   $_ =~ s/\tMessor y/\tMessor sp. y/g;
   $_ =~ s/Lasius ¿\?\t/Lasius sp.\t/g;
   $_ =~ s/Goniomma\t/Goniomma sp.\t/g;
   $_ =~ s/sp ¿hipanicumsp.\t/sp.\t/g;
   $_ =~ s/pendiente de ID\t/sp.\t/g;
   $_ =~ s/Formica\t/Formica sp.\t/g;
   $_ =~ s/Myrmica\t/Myrmica sp.\t/g;
   $_ =~ s/enanas\t|enana\t/sp.\t/g;
   $_ =~ s/Lasius\t/Lasius sp.\t/g;
   $_ =~ s/sp\(creo\)\t/sp.\t/g;
   $_ =~ s/¿rubrasp.\t/sp.\t/g;
   $_ =~ s/sp negra\t/sp.\t/g;
   $_ =~ s/supongo\t/sp.\t/g;
   $_ =~ s/¿.\..\?\t/sp.\t/g;
   $_ =~ s/\?\t/sp.\t/g;
   # Evitar creences i dubtes
   $_ =~ s/subfamilia ponerinae posible cryptopone\t/Cryptopone sp.\t/g;
   $_ =~ s/pigmaea \(plagiolepis\?\?\)\t/Plagiolepis pygmaea\t/g;
   $_ =~ s/sp \(Probablemente sylvaticus\)\t/sylvaticus\t/g;
   $_ =~ s/sp \(posible rosenhaueri\)\t/rosenhaueri\t/g;
   $_ =~ s/sp. \(posiblemente L. flavus\)\t/flavus\t/g;
   $_ =~ s/sp. \(niger\)\t|sp \(niger \?\)\t/niger\t/g;
   $_ =~ s/sp \(posiblemente auberti\)\t/auberti\t/g;
   $_ =~ s/¿Tetramorium sp.sp.\t/Tetramorium sp.\t/g;
   $_ =~ s/sp. \(meridionalis\?\)\t/meridionalis\t/g;
   $_ =~ s/\(seguramente Barbarus\)\t/barbarus\t/g;
   $_ =~ s/\(seguramente barbarus\)\t/barbarus\t/g;
   $_ =~ s/\(posiblemente Grandis\)\t/grandis\t/g;
   $_ =~ s/sp  \(creo que iberica\)\t/iberica\t/g;
   $_ =~ s/sp \(¿fairchildi\?\)\t/fairchildi\t/g;
   $_ =~ s/creo k messor.\..\.\t/Messor sp.\t/g;
   $_ =~ s/sp. ¿rufibarbissp.\t/rufibarbis\t/g;
   $_ =~ s/,creo que pallidula\t/pallidula\t/g;
   $_ =~ s/sp \(posible L. niger\)\t/niger\t/g;
   $_ =~ s/sp. \(caespitoum\)\t/caespitum\t/g;
   $_ =~ s/sp. \(posible fusca\)\t/fusca\t/g;
   $_ =~ s/sp. \(posible niger\)\t/niger\t/g;
   $_ =~ s/sp ¿hipanicumsp.\t/hispanicus\t/g;
   $_ =~ s/¿ hispanica sp.\t/hispanicus\t/g;
   $_ =~ s/sp \(semilaeve\)\t/semilaeve\t/g;
   $_ =~ s/graminicolasp.\t/graminicola\t/g;
   $_ =~ s/¿rufibarbissp.\t/rufibarbis\t/g;
   $_ =~ s/\(barbarus\?\)\t/barbarus\t/g;
   $_ =~ s/¿semileavesp.\t/semileave\t/g;
   $_ =~ s/capitatussp.\t/capitatus\t/g;
   $_ =~ s/sp ¿grandissp.\t/grandis\t/g;
   $_ =~ s/¿messorsp.\t/Messor sp.\t/g;
   $_ =~ s/, quiza fallax\t/fallax\t/g;
   $_ =~ s/sp. \(flavus\)\t/flavus\t/g;
   $_ =~ s/\(barbarus\)\t/barbarus\t/g;
   $_ =~ s/¿¿nigerrimun\?sp.\t/sp.\t/g;
   $_ =~ s/baeticumsp.\t/baeticum\t/g;
   $_ =~ s/flavus \/ miops\t/sp.\t/g;
   $_ =~ s/¿¿Fugax\?sp.\t/fugax\t/g;
   $_ =~ s/¿fuscasp.\t/fusca\t/g;
   $_ =~ s/¿rubrasp.\t/rubra\t/g;
   # Errors tipogràfics
   $_ =~ s/\tCatglyphis|\tCatagyphis|\tcatagliphis|\tCatagliphis/\tCataglyphis/g;
   $_ =~ s/Linepitema humille\t|Linepitema Humile\t/Linepithema humile\t/g;
   $_ =~ s/crematoghanster studellaris\t/Crematogaster scutellaris\t/g;
   $_ =~ s/Barabarus\t|brabarus\t|babarus\t|barburus\t/barbarus\t/g;
   $_ =~ s/\tphidole|\tpeidole|\tPhidole|\tPheidolle/\tPheidole/g;
   $_ =~ s/ scutelaris\t| Scuterallis\t/ scutellaris\t/g;
   $_ =~ s/Camponotusfallax\t/Camponotus fallax\t/g;
   $_ =~ s/\tLaisus|\tlassius|\tLassius/\tLasius/g;
   $_ =~ s/Palliudula\t|Palllidula\t/pallidula\t/g;
   $_ =~ s/nigerrium\t|Nigerrium\t/nigerrimum\t/g;
   $_ =~ s/\t¿Tetramoriumsp./\tTetramorium sp./g;
   $_ =~ s/semileave\t|semialeve\t/semilaeve\t/g;
   $_ =~ s/lasioide\t|lasiodes\t/lasioides\t/g;
   $_ =~ s/\taphaegnogaster/\tAphaenogaster/g;
   $_ =~ s/Camponotussp.\t/Camponotus sp.\t/g;
   $_ =~ s/tetramonium\t/Tetramorium sp.\t/g;
   $_ =~ s/punctatisima\t/punctatissima\t/g;
   $_ =~ s/\tOdontimachus/\tOdontomachus/g;
   $_ =~ s/\tMirmica|\tMirmyca/\tMyrmica/g;
   $_ =~ s/pygmea\t|pugmaea\t/pygmaea\t/g;
   $_ =~ s/\tPlagiolepsis/\tPlagiolepis/g;
   $_ =~ s/\ttetramonium/\tTetramorium/g;
   $_ =~ s/\ttetramoriun/\tTetramorium/g;
   $_ =~ s/\tlinephitema/\tLinepithema/g;
   $_ =~ s/fulginosus\t/fuliginosus\t/g;
   $_ =~ s/\tMesor|\tMessus/\tMessor/g;
   $_ =~ s/\tCamponatus/\tCamponotus/g;
   $_ =~ s/\tSolemnosis/\tSolenopsis/g;
   $_ =~ s/\tAenergates/\tAnergates/g;
   $_ =~ s/\tMirmicina/\tMyrmecina/g;
   $_ =~ s/dulcinaea\t/dulcineae\t/g;
   $_ =~ s/ iberica\t/ ibericus\t/g;
   $_ =~ s/\tTapinomia/\tTapinoma/g;
   $_ =~ s/\tFórmica /\tFormica /g;
   $_ =~ s/aetiops\t/aethiops\t/g;
   $_ =~ s/ibérica\t/ibericus\t/g;
   $_ =~ s/Auberty\t/auberti\t/g;
   $_ =~ s/sp. \?sp.\t/sp.\t/g;
   # Evitar punt final (excepte per sp.)
   $_ =~ s/MESSOR B.\t/Messor barbarus\t/g;
   $_ =~ s/hispanicum.\t/hispanicum\t/g;
   $_ =~ s/lasioides.\t/lasioides\t/g;
   $_ =~ s/ruginode.\t/ruginode\t/g;
   $_ =~ s/pygmaea.\t/pygmaea\t/g;
   # No fer abreviacions
   $_ =~ s/C. scutellaris\t|C.scutellaris\t/Crematogaster scutellaris\t/g;
   $_ =~ s/\tM. barbarus/\tMessor barbarus/g;
   $_ =~ s/Messor b.\t/Messor barbarus\t/g;
   # Altres
   $_ =~ s/\tHormigas hemíferas\t|\tHormigas melíferas\t|\tHieleras\t|\tHormigas Hieleras\t/\tDesconocida\t/g;
   $_ =~ s/Chthonolasius. probable Lasius rabaudi\t/Lasius rabaudi\t/g;
   $_ =~ s/Sin Identificar\t|Incierta\t|desconocida\t/Desconocida\t/g;
   $_ =~ s/\t6 Reinas de C. Cruentus\t/\tCamponotus cruentatus\t/g;
   $_ =~ s/alados de plagiolepys sp en nidos\t/Plagiolepis sp.\t/g;
   $_ =~ s/alados de plagiolepys sp en nidos\t/Plagiolepis sp.\t/g;
   $_ =~ s/desconozco \(pequeña\)\t/Desconocida\t/g;
   $_ =~ s/mixtus \(Chthonolasius\)\t/mixtus\t/g;
   $_ =~ s/y otra especie más pequeña\t/sp.\t/g;
   $_ =~ s/ACROMIRMEX   ATTAS\t/Desconocida\t/g;
   $_ =~ s/Acromyrmex o Atta\t/Desconocida\t/g;
   $_ =~ s/Cataglyphis\t/Cataglyphis sp.\t/g;
   $_ =~ s/barbarus sp.\t/barbarus\t/g;
   $_ =~ s/Pheidole\t/Pheidole sp.\t/g;
   $_ =~ s/\tLasius\t/\tLasius sp.\t/g;
   $_ =~ s/cfr. invicta\t/invicta\t/g;
   $_ =~ s/\?sp.\t/Desconocida\t/g;
}

# Guardar

open (F, ">./vols_2.txt");
binmode(F, ":utf8");

foreach (@lin){
   print F "$_\n";
}

close (F);

