#! /usr/bin/perl
# Script per descarregar tots es vols de lamarabunta.org

#use strict;
use LWP::Simple;
use warnings;
use encoding 'utf8';

@lin = ();

open F, "./vols_3.txt" or die "No s'ha obert el fitxer!!!";
binmode(F, ":utf8");

# Carregam les dades del fitxer
$i = 0;
while ($L = <F>) {  # Per a cada linia d'es fitxer
   chop($L);        # Llevam es salt de linia
   $lin[$i] = $L;   # Guardam sa linia
   $i++;
}

close (F);

# Inicialitzacions previes.
my %anyos  = ();
my @meses  = ('','Enero','Febrero','Marzo','Abril','Mayo','Junio','Julio','Agosto','Septiembre','Octubre','Noviembre','Diciembre');
my %meses  = ();
my %users  = ();
my %especi = ();
my @genere = ('Messor','Lasius','Camponotus','Tetramorium','Pheidole','Crematogaster','Formica','Cataglyphis','Tapinoma','Solenopsis','Aphaenogaster','Myrmica','Plagiolepis','Cardiocondyla','Hypoponera','Temnothorax','Goniomma','Linepithema','Reticulitermes','Myrmecina','Polyergus','Cryptopone','Nylanderia','Oxyopomyrmex','Atta','Proceratium','Ectatomma','Kalotermes','Bothriomyrmex','Paratrechina','Strongylognathus','Neivamyrmex','Pogonomyrmex','Acromyrmex','Monomorium','Anergates','Odontomachus','Desconocida');

my %genere = ();
my %HgenM = ();
my %HgenE = ();

# Conteig
foreach (@lin){
   @par = split /\t/,$_;       # Separa per camps
   @seg = split /\//,$par[0];  # Separa el camp fecha
   @gen = split / /,$par[1];   # Separa genere de sp
   $anyos{$seg[2]}++;
   $meses{$seg[1]}++;
   $users{$par[2]}++;
   $especi{$par[1]}++;
   $genere{$gen[0]}++;
   $HgenM{$gen[0]}{$meses[$seg[1]]}++; # Conta els generes cada mes
   if ($gen[0] ne "Desconocida"){
      if ($gen[1] ne "sp."){
         $HgenE{$gen[0]}{$meses[$seg[1]]}{$gen[1]}++; # Conta els generes cada mes i cada especie
      } else {
         $HgenE{$gen[0]}{$meses[$seg[1]]}{Indeterminados}++;
      }
   } else {
      $HgenE{$gen[0]}{$meses[$seg[1]]}{Desconocida}++;
   }
}

# Vols per anys
print "\[list\] * Vuelos por años ($i vuelos en ".keys(%anyos)." años):\[/list\]\nAño, Num. Vuelos, Porcentaje\n";

for my $a (sort keys %anyos){
   $var = ($anyos{$a}*100)/$i;
   $percent = sprintf '%.2f', $var;
   print "$a, $anyos{$a}, $percent%\n";
}

# Vols per mesos
print "\n\[list\] * Vuelos por meses ($i vuelos en 12 meses):\[/list\]\nMes, Num. Vuelos, Porcentaje\n";

for my $a (sort keys %meses){
   $var = ($meses{$a}*100)/$i;
   $percent = sprintf '%.2f', $var;
   print "$meses[$a], $meses{$a}, $percent%\n";
}

# Vols per usuari
my $max = 20;
print "\n\[list\] * Vuelos registrados por usuario ($i vuelos con ".keys(%users)." usuarios):\n   \[list\]- Solo los $max usuarios más activos\[/list\]\[/list\]\nNombre, Num. Vuelos, Porcentaje\n";

my $cont = 0;
foreach my $u (sort {$users{$b} <=> $users{$a}} keys %users){
   $cont++;
   $var = ($users{$u}*100)/$i;
   $percent = sprintf '%.2f', $var;
   print "$u, $users{$u}, $percent%\n";
   last if $cont == $max
}

# Vols per genere
print "\n\[list\] * Vuelos registrados por genero ($i vuelos con ".keys(%genere)." generos diferentes):\[/list\]\nNombre, Num. Vuelos, Porcentaje\n";

foreach my $s (sort {$genere{$b} <=> $genere{$a}} keys %genere){
   if ($s ne "Desconocida"){
      $var = ($genere{$s}*100)/$i;
      $percent = sprintf '%.2f', $var;
      print "$s, $genere{$s}, $percent%\n";
   }
}

$var = ($genere{"Desconocida"}*100)/$i;
$percent = sprintf '%.2f', $var;
print "Desconocida\t$genere{Desconocida}\t$percent%\n";   

# Vols per genere i mes
print "\n\[list\] * Vuelos registrados por genero ($i vuelos con ".keys(%genere)." generos diferentes) i por mes. Entre paréntesis la cantidad de vuelos hasta la fecha de dicho género el mes indicado y el porcentaje en todo el género.\[/list\]\n";

foreach my $s0 (@genere){
   print "\[b\]\[i\]$s0\[/i\] sp.\[/b\]\n   \[list\]";
   my $primero = 1;
   for my $s1 (@meses){
      if ($s1 ne ""){
         if ($HgenM{$s0}{$s1}){
            if ($primero){
               $var = ($HgenM{$s0}{$s1}*100)/$genere{$s0};
               $percent = sprintf '%.2f', $var;
               print "$s1 ($HgenM{$s0}{$s1}, $percent%)";
               $primero = 0;
            } else {
               $var = ($HgenM{$s0}{$s1}*100)/$genere{$s0};
               $percent = sprintf '%.2f', $var;
               print ", $s1 ($HgenM{$s0}{$s1}, $percent%)";
            }
         } else {
            if ($primero){
               print "$s1 (0, 0.00%)";
               $primero = 0;
            } else {
               print ", $s1 (0, 0.00%)";
            }
         }
      }
   }
   print "\[/list\]\n";
}

# Vols per genere, mes i espècie
print "\n\[list\] * Vuelos registrados por genero ($i vuelos con ".keys(%genere)." generos diferentes) por mes y especie. Entre paréntesis la cantidad de vuelos hasta la fecha\[/list\]\n";

foreach my $s0 (@genere){
   print "\[b\]\[i\]$s0\[/i\] sp.\[/b\]\n";
   for my $s1 (@meses){
      if ($HgenE{$s0}{$s1}){
         print "\[list\]   \[b\]$s1\[/b\] -->";
         my $primero = 1;
         for my $s2 (keys %{$HgenE{$s0}{$s1}}){
            if ($s2 ne "Indeterminados"){
               if ($primero){
                  print " $s2 ($HgenE{$s0}{$s1}{$s2})";
                  $primero = 0;
               } else {
                  print ", $s2 ($HgenE{$s0}{$s1}{$s2})";
               }
            }
         }
         if ($HgenE{$s0}{$s1}{Indeterminados}){
            if ($primero){
               print " Indeterminados ($HgenE{$s0}{$s1}{Indeterminados})";
            } else {
               print ", Indeterminados ($HgenE{$s0}{$s1}{Indeterminados})";
            }
         }
         print "\[/list\]\n";
      }
   }
}

# Vols per especie
#print "\n * Vuelos registrados por especie ($i vuelos con ".keys(%especi)." especies diferentes):\nNombre\t# Vuelos\tPorcentaje\n";

#foreach my $s (sort {$especi{$b} <=> $especi{$a}} keys %especi){
#   $var = ($especi{$s}*100)/$i;
#   $percent = sprintf '%.2f', $var;
#   print "$s\t$especi{$s}\t$percent%\n";
#}

